//
// Created by HUTAO on 2017/6/27.
//

#ifndef YYPROTO_OPENSSLPROXY_H
#define YYPROTO_OPENSSLPROXY_H

#include "commondefine.h"
#if defined(__MAC_OS__)
#include "opensslOSX/crypto.h"
#include "opensslOSX/err.h"
#include "opensslOSX/rand.h"
#include "opensslOSX/bn.h"
#include "opensslOSX/rsa.h"
#include "opensslOSX/rc4.h"
#include "opensslOSX/md5.h"
#include "opensslOSX/sha.h"
#include "opensslOSX/blowfish.h"
#else
#include "openssl/crypto.h"
#include "openssl/err.h"
#include "openssl/rand.h"
#include "openssl/bn.h"
#include "openssl/rsa.h"
#include "openssl/rc4.h"
#include "openssl/md5.h"
#include "openssl/sha.h"
#include "openssl/blowfish.h"
#endif
NAMESPACE_BASEMOD_BEGIN

	class opensslproxy
	{
	public:
		static RSA* Proto_RSA_generate_key(int bits, unsigned long e, void (*callback)(int, int, void*), void * cb_arg);
		static void Proto_RSA_free_key(RSA* key);
//        static void Proto_RAND_seed(const void *buf, int num);
		static int Proto_BN_bn2bin(const BIGNUM *a, unsigned char* to);
		static int Proto_RSA_private_decrypt(int flen, const unsigned char *from, unsigned char* to, RSA *rsa, int padding);
		static void Proto_RC4_set_key(RC4_KEY *key, int len, const unsigned char *data);
		static void Proto_RC4(RC4_KEY *key, size_t len, const unsigned char* indata, unsigned char* outdata);
		static unsigned char* Proto_RAW_MD5(const unsigned char* d, size_t n, unsigned char* md);
		static void Proto_MD5(const std::string& indata, std::string& outdata);
		static unsigned char* Proto_SHA1(const unsigned char* d, size_t n, unsigned char *md);
		static void Proto_SHA1(const std::string& indata, std::string& outdata);
		
//        static void Proto_BF_set_key(BF_KEY *key, int len, const unsigned char *data);
//        static void Proto_BF_cbc_encrypt(const unsigned char *in, unsigned char *out, long length,
//                        const BF_KEY *schedule, unsigned char *ivec, int enc);
	};
NAMESPACE_BASEMOD_END
#endif //YYLIVESDK_PARENT_OPENSSLPROXY_H
